﻿
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "maibu_sdk.h"
#include "maibu_res.h"

static int32_t g_window_id             = -1;
static int32_t g_layer_id_hm           = -1;
static int32_t g_layer_id_wmd          = -1;
static int32_t g_layer_id_xyz          = -1;
static int32_t g_layer_id_city         = -1;
static int32_t g_layer_id_pm_str       = -1;
static int32_t g_layer_id_aqi          = -1;
static int32_t g_layer_id_aqi_str      = -1;
static int32_t g_layer_id_temp         = -1;
static int32_t g_layer_id_icon         = -1;
static int32_t g_layer_id_bg           = -1;
static int32_t g_layer_id_waiting      = -1;
static int32_t g_layer_id_waiting_str  = -1;

static uint8_t g_callback_request_flag = 0;//用来标志是否是快速查询状态

static char    g_city[20]              = {0};

static uint32_t g_comm_id_gps          = 0;
static uint32_t g_comm_id_web_city     = 0;
static uint32_t g_comm_id_web_weather  = 0;

static int32_t g_temperature           = 0;
static int32_t g_curPm                 = 0;
static int32_t g_level				   = 0;
static int32_t g_Pm25                  = 0;
static int32_t g_Pm10                  = 0;
static char weather_info[20] 	       = {0};


static uint32_t g_weather_icon_key     = 0;

static uint32_t g_request_count        = 0;

static char wday[7][8]={"周日","周一","周二","周三","周四","周五","周六"}; 

static uint8_t gps_timer               = 0;


//#define CODE_SIZE_OPTIMIZE_CLOSE 0 //空间优化代码控制宏



#if 0
static uint8_t g_ble_connenct_flag     = 0;
static uint8_t g_ble_detect_timer_id   = 0;
#endif

#define CALLBACK_1_MIN				1

#define CITY_EMPTY					3

#define GPS_DATA_SIZE				16

static char g_lon[GPS_DATA_SIZE] = {0};
static char g_lat[GPS_DATA_SIZE] = {0};

#define get_address_url		"http://api.map.baidu.com/geocoder/v2/?ak=xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx&output=json&pois=0&location="
#define CITY_KEY			"city,district"
#define WEATHER_KEY			"temperature,curPm,pm10,info,level"


#define WEATHER_URL		"http://op.juhe.cn/onebox/weather/query?key=xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx&cityname="



#define STR_PM25		"PM2.5"
#define STR_PM10		"PM10"


#define AQI_LV_NULL	"暂无空气数据"
#define AQI_LV_1	"空气质量优"
#define AQI_LV_2	"空气质量良好"
#define AQI_LV_3	"轻度污染"
#define AQI_LV_4	"中度污染"
#define AQI_LV_5	"重度污染"
#define AQI_LV_6	"严重污染"

#define AQI_LV_TH1	50
#define AQI_LV_TH2	100
#define AQI_LV_TH3	150
#define AQI_LV_TH4	200
#define AQI_LV_TH5	300

#define WEATHER_CLOUDY		"多云"
#define WEATHER_FOG_1		"雾"
#define WEATHER_FOG_2		"霾"
#define WEATHER_OVERCAST	"阴"
#define WEATHER_RAIN		"雨"
#define WEATHER_SNOW		"雪"
#define WEATHER_SUNNY		"晴"

#define WAITING_FOR_WEATHER		"正在刷新天气"

#define JSON_ERROR			-1


//得到空气质量等级 
char * get_aqi_level(int32_t aqi_level)
{

#if 0

	char * level = NULL;
	if(aqi_data <= AQI_LV_TH1)
	{
		level = AQI_LV_0;
	}
	else if(aqi_data <= AQI_LV_TH2)
	{
		level = AQI_LV_1;
	}
	else if(aqi_data <= AQI_LV_TH3)
	{
		level = AQI_LV_2;
	}
	else if(aqi_data <= AQI_LV_TH4)
	{
		level = AQI_LV_3;
	}
	else if(aqi_data <= AQI_LV_TH5)
	{
		level = AQI_LV_4;
	}
	else
	{
		level = AQI_LV_5;
	}
	return level;
	
#endif

#if 0

	char * str[] = {AQI_LV_0,AQI_LV_1,AQI_LV_2,AQI_LV_3,AQI_LV_4,AQI_LV_5};

	if(aqi_level > sizeof(str)/sizeof(char *))
	{
		return NULL;
	}

	return str[aqi_level - 1];

#endif

	char * level = NULL;

	#if 1

	//用 if else比用switch小12个byte
	if(aqi_level == 1)
	{
		level = AQI_LV_1;
	}
	else if(aqi_level == 2)
	{
		level = AQI_LV_2;
	}
	else if(aqi_level == 3)
	{
		level = AQI_LV_3;
	}
	else if(aqi_level == 4)
	{
		level = AQI_LV_4;
	}
	else if(aqi_level == 5)
	{
		level = AQI_LV_5;
	}
	else if(aqi_level == 6)
	{
		level = AQI_LV_6;
	}
	else
	{
		level = AQI_LV_NULL;
	}
	#else

	switch(aqi_level)
	{
		case 1 : level = AQI_LV_1;break;
		case 2 : level = AQI_LV_2;break;
		case 3 : level = AQI_LV_3;break;
		case 4 : level = AQI_LV_4;break;
		case 5 : level = AQI_LV_5;break;
		case 6 : level = AQI_LV_6;break;
		default: level = AQI_LV_NULL;
	}

	#endif
	
	return level;
	
}

//把str类型的GPS数据转为int
int GPS_STR_TO_INT(char * str)
{
	char data_buf[GPS_DATA_SIZE] = {0};
	char * decimal = &data_buf[0];
	
	memcpy(data_buf,str,sizeof(data_buf)-1);

	int i = 0;
	
	for(i = 0; i< GPS_DATA_SIZE ;++i)
	{
		if(data_buf[i] == '.')
		{
			decimal = &data_buf[i];
			break;
		}
		if(data_buf[i] == '\0')
		{
			break;
		}
	}
	
	if(decimal == &data_buf[0])
	{
		
		return 0;
	}
	
	*decimal = '\0';
	++decimal;
	decimal[2] = '\0';
	
	return atoi(data_buf)*100 + atoi(decimal)+1;
}

//比较字符串类型的GPS数据
bool compare_gps_data(char * old_param,char * new_param)
{

	int old_data,new_data;
	
	old_data = GPS_STR_TO_INT(old_param);
	new_data = GPS_STR_TO_INT(new_param);

	if(new_data && old_data)
	{
		if((new_data - old_data > 10)||(new_data - old_data < -10) )
		{
			return true;
		}
	}

	return false;

	
}


//设置等待窗口显示字符串
void set_waiting_info_str(char *str,bool flag)
{
	//g_waiting_str = str;//优化空间

	/*根据窗口ID获取窗口句柄*/
	P_Window p_window = app_window_stack_get_window_by_id(g_window_id); 

	
	if (NULL != p_window)
	{
	

		P_Layer p_layer_waiting_str = app_window_get_layer_by_id(p_window,g_layer_id_waiting_str);

		app_layer_set_text_text(p_layer_waiting_str, str);

		maibu_layer_set_visible_status(p_layer_waiting_str,flag);

		/*更新窗口显示*/
		app_window_update(p_window);

	}
}

uint32_t get_weather_icon(char * str,bool day_or_night)
{
	uint32_t weather_icon_key = 0;
	if( strlen(str) == 0)
	{

	}
	else if(memcmp(str,WEATHER_SUNNY,strlen(WEATHER_SUNNY)) == 0 )
	{
		weather_icon_key = (day_or_night)?RES_BITMAP_WATCHFACE_WEATHER_SUNNY_DAY:RES_BITMAP_WATCHFACE_WEATHER_SUNNY_NIGHT;
	}
	else if(memcmp(str,WEATHER_OVERCAST,strlen(WEATHER_OVERCAST)) == 0 )
	{
		weather_icon_key = RES_BITMAP_WATCHFACE_WEATHER_OVERCAST;
	}
	else if(memcmp(str,WEATHER_CLOUDY,strlen(WEATHER_CLOUDY)) == 0 )
	{
		weather_icon_key = (day_or_night)?RES_BITMAP_WATCHFACE_WEATHER_CLOUDY_DAY:RES_BITMAP_WATCHFACE_WEATHER_CLOUDY_NIGHT;
	}
	else if((memcmp(str,WEATHER_FOG_1,strlen(WEATHER_FOG_1)) == 0 )||(memcmp(str,WEATHER_FOG_2,strlen(WEATHER_FOG_2)) == 0 ))
	{
		weather_icon_key = RES_BITMAP_WATCHFACE_WEATHER_FOG;
	}
	else
	{
		if(strstr(str,WEATHER_SNOW) != NULL)
		{
			weather_icon_key = RES_BITMAP_WATCHFACE_WEATHER_SNOW;
		}
		else
		{
			weather_icon_key = RES_BITMAP_WATCHFACE_WEATHER_RAIN;
		}
	}

	return weather_icon_key;
}


bool get_date_flag(void)
{

	struct date_time datetime;
	app_service_get_datetime(&datetime);

	if((datetime.hour >= 7)&&(datetime.hour < 19))
	{
		return true;
	}
	else
	{
		return false;
	}
}


//更新天气图片
void update_weather_icon(P_Window p_window)
{

	//更新天气图片
	GBitmap bitmap_icon;
	P_Layer p_layer_icon = app_window_get_layer_by_id(p_window, g_layer_id_icon);
	g_weather_icon_key = get_weather_icon(weather_info,get_date_flag());
	res_get_user_bitmap(g_weather_icon_key, &bitmap_icon);
	app_layer_set_bitmap_bitmap(p_layer_icon, &bitmap_icon);
	
}


//请求天气数据回调
void weather_info_callback(const uint8_t *buff,uint16_t size)
{
	char buffer[40] = {0};
	char * pm_str = NULL;

	g_request_count = 0;//清空请求计数
	g_callback_request_flag = 0; //清空回调请求标志

	maibu_get_json_int(buff, "temperature", &g_temperature);
	maibu_get_json_int(buff, "pm10", &g_Pm10);
	maibu_get_json_int(buff, "curPm", &g_curPm);
	
	if(maibu_get_json_str(buff, "info", buffer,sizeof(weather_info)) != JSON_ERROR )
	{//防止数据为空导致的数据清空
		maibu_get_json_str(buff, "info", weather_info,sizeof(weather_info));
	}
	else
	{
		return;
	}
	
	maibu_get_json_int(buff, "level",&g_level);
	
	//pm_str = (g_Pm25 >= g_Pm10)?(STR_PM25):(STR_PM10);
	pm_str = STR_PM25;
	
	//刷新界面
	/*根据窗口ID获取窗口句柄*/
	P_Window p_window = app_window_stack_get_window_by_id(g_window_id); 
	if (NULL == p_window)
	{
		return;
	}


	maibu_layer_set_visible_status(app_window_get_layer_by_id(p_window,g_layer_id_waiting_str),false);
	maibu_layer_set_visible_status(app_window_get_layer_by_id(p_window,g_layer_id_waiting),false);
	
	//更新空气质量指数
	sprintf(buffer, "%d", g_curPm);
	app_layer_set_text_text(app_window_get_layer_by_id(p_window, g_layer_id_aqi), buffer);
	
	//更新空气质量
	//sprintf(buffer, "%s", get_aqi_level(g_level));
	app_layer_set_text_text(app_window_get_layer_by_id(p_window, g_layer_id_aqi_str), get_aqi_level(g_level));

	//更新空气质量PM标识
	//sprintf(buffer, "%s", pm_str);
	app_layer_set_text_text(app_window_get_layer_by_id(p_window, g_layer_id_pm_str),pm_str);
	
	//更新温度
	sprintf(buffer,"%d",g_temperature);
	app_layer_set_text_text(app_window_get_layer_by_id(p_window, g_layer_id_temp), buffer);

	//更新天气图片
	update_weather_icon(p_window);
	
	
	/*更新窗口显示*/
	app_window_update(p_window);
	
}

//请求天气数据
void request_weather_info(char * city_name)
{

	//sprintf(url,"%s&key=%s",city_name,WEATHER_API_KEY);

	char url[256] = {0};

	sprintf(url,"%s",WEATHER_URL);
	
	if(city_name != NULL)
	{
		int i = 0,j = 0;
		for(i;(city_name[i] != '\0')&&(j < sizeof(url)) ;++i)
		{
			sprintf(url,"%s%%%x",url,city_name[i]);
		}
		//buffer[j] = '\0';
	}
	
	//set_waiting_info_str(WAITING_FOR_WEATHER,(g_weather_icon_key == 0));
	
	maibu_comm_register_web_callback(weather_info_callback);

	int time_flag = 0;
	if(get_date_flag())
	{
		time_flag = 5;
	}
	else
	{
		time_flag = 15;
	}
	//g_comm_id_web_weather = maibu_comm_request_web(url,WEATHER_KEY,1000*60*time_flag);
	g_comm_id_web_weather = maibu_comm_request_web(url,WEATHER_KEY,0);


}

/*******************************************************
@ function name: cut_cityname
@ 功能说明     : 去除城市名末尾的形容词，如"市"、"县"
@ 参数说明     :
			cityName: 原始的城市名
			str     : 需要去掉的形容词
*******************************************************/
void cut_cityname(char * cityName,char *str)
{
	char* end_ptr = NULL;

	if((end_ptr = strstr(cityName,str)) != NULL )
	{
		if(strlen(end_ptr) > strlen(str))
		{
			cityName[strlen(cityName)-strlen(str)-1] = '\0';
		}
		else
		{
			*end_ptr = '\0';
		}
	}
}

//请求城市信息回调
void city_info_callback(const uint8_t *buff,uint16_t size)
{
	char city_name[40];
	int flag = 1;
	maibu_get_json_str(buff,"city",city_name,sizeof(city_name));
	city_name[sizeof(city_name) - 1] = '\0';
	if((strlen(city_name) == (sizeof(city_name) - 1))|| (strstr(city_name,"盟") != NULL) )
	{//如果城市名过长，如果有"盟"字，则使用二级城市
		maibu_get_json_str(buff,"district",city_name,sizeof(city_name));
	}
	
	//flag = memcmp(city_name,g_city,sizeof(g_city));
	
	
	//刷新界面
	/*根据窗口ID获取窗口句柄*/
	P_Window p_window = app_window_stack_get_window_by_id(g_window_id); 
	if (NULL == p_window)
	{
		return;
	}
	P_Layer p_layer_city = app_window_get_layer_by_id(p_window, g_layer_id_city);




	//去掉后面的城市末尾的字
	char* end_ptr = NULL;

	cut_cityname(&city_name[0],"市");
	cut_cityname(&city_name[0],"县");

	if(((end_ptr = strstr(city_name,"特别行政区")) != NULL ) || 
			((end_ptr = strstr(city_name,"地区")) != NULL ))
	{//屏蔽"特别行政区"，屏蔽"地区"，防止请求不到数据
		*end_ptr = '\0';
	}


	if(strcmp(g_city,city_name) != 0)
	{//如果城市变化，显示等待信息
	
		maibu_layer_set_visible_status(app_window_get_layer_by_id(p_window,g_layer_id_waiting_str),true);
		maibu_layer_set_visible_status(app_window_get_layer_by_id(p_window,g_layer_id_waiting),true);
		
	}

	
	sprintf(g_city, "%s", city_name);
	app_layer_set_text_text(p_layer_city, g_city);

	
	/*更新窗口显示*/
	app_window_update(p_window);
	
	//根据城市信息获取天气信息
	request_weather_info(g_city);

}

//请求城市信息
void request_city_info(char *lon,char *lat)
{
	char url[256];
	sprintf(url,"%s%s,%s",get_address_url,lat,lon);

	sprintf(g_lat,"%s",lat);
	sprintf(g_lon,"%s",lon);
	
	//城市位置相关注册与请求
	maibu_comm_register_web_callback(city_info_callback);
	g_comm_id_web_city = maibu_comm_request_web(url,CITY_KEY,0);

	//set_waiting_info_str(WAITING_FOR_CITY,(g_weather_icon_key == 0));
}

//gps 请求超时处理
void gps_request_timeout(date_time_t dt, uint32_t millis ,void* context)
{
   request_weather_info(g_city);
   app_service_timer_unsubscribe(gps_timer);
}



//请求GPS数据回调
void gps_info_callback(enum ERequestPhone  type,void * context)
{
	SGpsAltitude * gps_data = (SGpsAltitude *)context;

	app_service_timer_unsubscribe(gps_timer);

	if((compare_gps_data(gps_data->lon,g_lon) == true)
		||(compare_gps_data(gps_data->lat,g_lat) == true)|| (strlen(g_city)< CITY_EMPTY) ) 
	{
		request_city_info(gps_data->lon,gps_data->lat);
	}
	else
	{
		request_weather_info(g_city);
	}
	
}

//请求GPS数据
void request_gps_info()
{
	g_comm_id_gps = maibu_comm_request_phone(ERequestPhoneGPSAltitude, NULL);

	gps_timer = app_service_timer_subscribe(1000*10,gps_request_timeout,NULL);

	set_waiting_info_str(WAITING_FOR_WEATHER,(g_weather_icon_key==0));

}




void time_change(enum SysEventType type, void *context)
{
	/*时间更改*/
	if (type == SysEventTypeTimeChange)
	{
		/*根据窗口ID获取窗口句柄*/
		P_Window p_window = app_window_stack_get_window_by_id(g_window_id); 
		if (NULL == p_window)
		{
			return;
		}
		
		/*获取当前时间*/
		struct date_time datetime;
		app_service_get_datetime(&datetime);
		char str[20] = "";
	
		/*获取小时分钟图层*/	
		P_Layer p_layer_hm = app_window_get_layer_by_id(p_window, g_layer_id_hm);
		if (NULL ==p_layer_hm)
		{
			return; 
		}

		/*设置图层内容*/
		sprintf(str, "%02d:%02d", datetime.hour, datetime.min);
		app_layer_set_text_text(p_layer_hm, str);	

		//时间变化更新天气图片
		if(g_weather_icon_key != 0)
		{
			update_weather_icon(p_window);
		}
		
		/*每天凌晨更新日期,这里可以优化,你懂的*/	
		if ((datetime.hour == 0))
		{
			P_Layer p_layer_wmd = app_window_get_layer_by_id(p_window, g_layer_id_wmd);
			if (p_layer_wmd)
			{
				//char wday[7][8]={"周日","周一","周二","周三","周四","周五","周六"}; 
				sprintf(str, "%02d-%02d %s", datetime.mon, datetime.mday, wday[datetime.wday]);
				app_layer_set_text_text(p_layer_wmd, str);	
			}
		}


		/*更新窗口显示*/
		app_window_update(p_window);
	}
}

void set_temp_layerText(LayerText* temp_LayerText,char * str,GRect rect,enum GAlign alignment, uint8_t font_type,uint8_t bound_width )
{
	temp_LayerText->text = str;
	temp_LayerText->frame = rect;
	temp_LayerText->alignment = alignment;
	temp_LayerText->font_type = font_type;
	temp_LayerText->bound_width = bound_width;
}

int32_t add_layerText_to_window(P_Window p_window,P_Layer p_layer,LayerText * temp_LayerText,enum GColor color)
{
	p_layer = app_layer_create_text(temp_LayerText);
	
	if(p_layer != NULL)
	{
		app_layer_set_bg_color(p_layer, color);
		return app_window_add_layer(p_window, p_layer);
	}
	return 0;
}

P_Window init_window(void)
{
	P_Window p_window = NULL;
	p_window = app_window_create();
	if (NULL == p_window)
	{
		return NULL;
	}

	char buffer[40] = {0};
	
	/*添加背景图片图层*/
	GRect temp_frame = {{0, 0}, {128, 128}};
	uint32_t *temp_frame_p = (uint32_t *)&temp_frame;

	LayerText temp_LayerText = {0};

	GBitmap temp_GBitmap = {0};

	P_Layer temp_P_Layer = NULL;
	
	res_get_user_bitmap(RES_BITMAP_WATCHFACE_WEATHER_BG, &temp_GBitmap);
	LayerBitmap lb_bg = {temp_GBitmap, temp_frame, GAlignLeft};	
	temp_P_Layer = app_layer_create_bitmap(&lb_bg);
	if(temp_P_Layer != NULL)
	{
		app_window_add_layer(p_window, temp_P_Layer);
	}

	//添加天气图片
	//temp_frame = {{0, 28}, {60, 80}};
	*temp_frame_p = 0x503c1c00;
	res_get_user_bitmap( g_weather_icon_key, &temp_GBitmap);
	LayerBitmap lb_icon = {temp_GBitmap, temp_frame, GAlignLeft};
	temp_P_Layer = app_layer_create_bitmap(&lb_icon);
	if(temp_P_Layer != NULL)
	{
		g_layer_id_icon = app_window_add_layer(p_window, temp_P_Layer);
	}

	/*添加温度图层*/
	//temp_frame = {{71, 52}, {30, 46}};
	*temp_frame_p = 0x2e1e3447;
	sprintf(buffer, "%d",g_temperature);
	set_temp_layerText(&temp_LayerText,buffer, temp_frame, GAlignRight, U_ASCII_ARIAL_30, 0);
	
	g_layer_id_temp = add_layerText_to_window(p_window,temp_P_Layer,&temp_LayerText,GColorWhite);
	

	/*添加空气质量指数标识图层*/
	//temp_frame = {{91,93},{12,36}};
	*temp_frame_p = 0x240c5d5b;
	//char * pm_str = (g_curPm == g_Pm25)?(STR_PM25):(STR_PM10);
	char * pm_str = STR_PM25;
	//sprintf();
	set_temp_layerText(&temp_LayerText,pm_str,temp_frame,GAlignRight,U_ASCII_ARIAL_12,0);
	
	g_layer_id_pm_str = add_layerText_to_window(p_window,temp_P_Layer,&temp_LayerText,GColorBlack);
	
	
	/*添加空气质量指数图层*/
	//temp_frame = {{87,103},{24,40}};
	*temp_frame_p = 0x28186757;
	sprintf(buffer,"%d",g_curPm);
	set_temp_layerText(&temp_LayerText,buffer,temp_frame,GAlignRight,U_ASCII_ARIAL_24,0);

	g_layer_id_aqi = add_layerText_to_window(p_window,temp_P_Layer,&temp_LayerText,GColorBlack);
	
	
	
	/*添加空气质量图层*/
	//temp_frame = {{4,112},{12,78}};
	*temp_frame_p = 0x4e0c7004;
	sprintf(buffer,"%s",get_aqi_level(g_level));
	set_temp_layerText(&temp_LayerText,buffer,temp_frame,GAlignLeft,U_ASCII_ARIAL_12,0);
	
	g_layer_id_aqi_str = add_layerText_to_window(p_window,temp_P_Layer,&temp_LayerText,GColorBlack);
	
	
	/*添加城市名称图层*/
	//temp_frame = {{12,93},{14,82}};
	*temp_frame_p = 0x500e5d0c;
	sprintf(buffer,"%s",g_city);
	set_temp_layerText(&temp_LayerText,buffer,temp_frame,GAlignLeft,U_ASCII_ARIAL_14,0);
	
	g_layer_id_city = add_layerText_to_window(p_window,temp_P_Layer,&temp_LayerText,GColorBlack);


	/*添加等待更新图片图层*/
	//temp_frame = {{0, 28}, {100, 128}};
	*temp_frame_p = 0x80641c00;
	res_get_user_bitmap(RES_BITMAP_WATCHFACE_WEATHER_UPDATING, &temp_GBitmap);
	LayerBitmap lb_waiting = {temp_GBitmap, temp_frame, GAlignLeft};	
	P_Layer layer_bitmap_waiting = app_layer_create_bitmap(&lb_waiting);
	if(layer_bitmap_waiting != NULL)
	{
		g_layer_id_waiting = app_window_add_layer(p_window, layer_bitmap_waiting);
	}

	/*添加等待更新提示图层*/
	//temp_frame = {{0,101},{14,128}};
	*temp_frame_p = 0x800e6500;
	//g_waiting_str = (g_waiting_str == NULL)?(WAITING_FOR_GPS):(g_waiting_str);//保持上一次的提示
	set_temp_layerText(&temp_LayerText,WAITING_FOR_WEATHER, temp_frame, GAlignCenter, U_ASCII_ARIAL_14, 0);
	P_Layer layer_text_waiting_str = app_layer_create_text(&temp_LayerText);
	if(layer_text_waiting_str != NULL)
	{
		app_layer_set_bg_color(layer_text_waiting_str, GColorBlack);
		g_layer_id_waiting_str = app_window_add_layer(p_window,layer_text_waiting_str);
	}
	
	if(g_weather_icon_key != 0)
	{
		maibu_layer_set_visible_status(layer_bitmap_waiting,false);
		maibu_layer_set_visible_status(layer_text_waiting_str,false);
	}
	

	/*添加小时分钟图层*/
	//temp_frame = {{73,2}, {20,53}};
	*temp_frame_p = 0x35140249;
	struct date_time t;
	app_service_get_datetime(&t);
	sprintf(buffer, "%02d:%02d", t.hour, t.min);
	set_temp_layerText(&temp_LayerText,buffer, temp_frame, GAlignRight, U_ASCII_ARIALBD_20, 0);
	
	g_layer_id_hm = add_layerText_to_window(p_window,temp_P_Layer,&temp_LayerText,GColorWhite);
	

	/*添加星期月图层*/
	//temp_frame = {{4, 4}, {12, 64}};
	*temp_frame_p = 0x400c0404;
	memset(buffer, 0, sizeof(buffer));
	
	sprintf(buffer, "%02d-%02d %s", t.mon, t.mday, wday[t.wday]);
	set_temp_layerText(&temp_LayerText, buffer,temp_frame, GAlignLeft,	U_ASCII_ARIAL_12, 0);
	
	g_layer_id_wmd = add_layerText_to_window(p_window,temp_P_Layer,&temp_LayerText,GColorWhite);
	

	return p_window;
}
 

void app_weather_update_timer_callback(date_time_t tick_time, uint32_t millis, void *context)
{	
	if((g_request_count >= 5)&&(g_callback_request_flag == 0))
	{//正常查询状态请求次数大于9次就显示提示信息
		//清空历史数据
		g_weather_icon_key = 0;
		weather_info[0]    = 0;
	
		/*根据窗口ID获取窗口句柄*/
		P_Window p_window = app_window_stack_get_window_by_id(g_window_id); 
		if (NULL == p_window)
		{
			return;
		}

		maibu_layer_set_visible_status(app_window_get_layer_by_id(p_window,g_layer_id_waiting_str),true);
		maibu_layer_set_visible_status(app_window_get_layer_by_id(p_window,g_layer_id_waiting),true);
		
	}
	else if((g_request_count >= 15)&&(g_callback_request_flag == 1))
	{//快速查询的状态下大于15次就退出快速查询
		g_request_count = 0;
		g_callback_request_flag = 0;
	}

	if(g_callback_request_flag == 0)
	{
		app_service_timer_subscribe(15*60*1000, app_weather_update_timer_callback, NULL);
	}

	
	request_gps_info();

	
	
	g_request_count++;
}


void weather_comm_result_callback(enum ECommResult result, uint32_t comm_id, void *context)
{
	/*如果上一次请求GPS通讯失败，并且通讯ID相同，则重新发送*/
	
	if ((result == ECommResultFail) && (comm_id == g_comm_id_gps))
	{
		if(strlen(g_city)>= CITY_EMPTY)
		{
			request_weather_info(g_city);
		}
		else
		{
			g_comm_id_gps = maibu_comm_request_phone(ERequestPhoneGPSAltitude,  NULL);
		}
	}

	/*如果上一次请求WEB通讯失败，并且通讯ID相同，则重新发送*/
	if ((result == ECommResultFail) && (comm_id == g_comm_id_web_city))
	{
		request_city_info(g_lon,g_lat);
	}
	
	/*如果上一次请求WEB通讯失败，并且通讯ID相同，则重新发送*/
	if ((result == ECommResultFail) && (comm_id == g_comm_id_web_weather))
	{
		request_weather_info(g_city);
	}
}

int main()
{

	/*创建消息列表窗口*/
	P_Window p_window = init_window(); 
	/*放入窗口栈显示*/
	g_window_id = app_window_stack_push(p_window);
	
	//请求GPS数据并注册回调
	request_gps_info();
	
	/*注册接受手机数据回调函数*/
	maibu_comm_register_phone_callback(gps_info_callback);
		
	//test
	//char city_name[20] = "深圳";
	//request_weather_info(city_name);
	//maibu_comm_register_web_callback(weather_info_callback);

	uint32_t request_time = 15 * 60 * 1000;//默认5分钟请求数据
	if(get_date_flag() == false)
	{
		request_time = 15 * 60 * 1000;
	}

	if(strlen(g_city) == 0)
	{//在没有城市数据的情况下进行快速查询
		request_time = 5 * 1000;//在没有获取过数据的情况下5秒获取一次数据

		g_callback_request_flag = 1;//设置快速查询标志
	}
	
	app_service_timer_subscribe(request_time, app_weather_update_timer_callback, NULL);	
	/*注册一个事件通知回调，当有时间改变时，立即更新时间*/
	maibu_service_sys_event_subscribe(time_change);

	/*注册通讯结果回调*/
	maibu_comm_register_result_callback(weather_comm_result_callback);

	return 0;

}















